import{s as Q,o as X,n as Y}from"../chunks/scheduler.9bc65507.js";import{S as ee,i as te,g as f,s as l,r as q,A as ae,h as m,f as a,c as p,j as I,u as j,x as S,k as V,y as v,a as r,v as A,d as E,t as U,w as R}from"../chunks/index.707bf1b6.js";import{T as ne}from"../chunks/Tip.c2ecdbf4.js";import{D as re}from"../chunks/Docstring.17db21ae.js";import{H as K}from"../chunks/Heading.342b1fa6.js";function se(y){let n,d='Learn more about using DeepSpeed with <a href="/docs/transformers/main/en/main_classes/trainer#transformers.Trainer">Trainer</a> in the <a href="../deepspeed">DeepSpeed</a> guide.';return{c(){n=f("p"),n.innerHTML=d},l(i){n=m(i,"P",{"data-svelte-h":!0}),S(n)!=="svelte-1bvvaxn"&&(n.innerHTML=d)},m(i,T){r(i,n,T)},p:Y,d(i){i&&a(n)}}}function ie(y){let n,d,i,T,g,C,u,N='<a href="https://github.com/microsoft/DeepSpeed" rel="nofollow">DeepSpeed</a>, powered by Zero Redundancy Optimizer (ZeRO), is an optimization library for training and fitting very large models onto a GPU. It is available in several ZeRO stages, where each stage progressively saves more GPU memory by partitioning the optimizer state, gradients, parameters, and enabling offloading to a CPU or NVMe. DeepSpeed is integrated with the <a href="/docs/transformers/main/en/main_classes/trainer#transformers.Trainer">Trainer</a> class and most of the setup is automatically taken care of for you.',x,h,W='However, if you want to use DeepSpeed without the <a href="/docs/transformers/main/en/main_classes/trainer#transformers.Trainer">Trainer</a>, Transformers provides a <code>HfDeepSpeedConfig</code> class.',P,c,L,_,M,s,$,O,b,B="This object contains a DeepSpeed configuration dictionary and can be quickly queried for things like zero stage.",Z,D,F=`A <code>weakref</code> of this object is stored in the module’s globals to be able to access the config from areas where
things like the Trainer object is not available (e.g. <code>from_pretrained</code> and <code>_get_resized_embeddings</code>). Therefore
it’s important that this object remains alive while the program is still running.`,G,w,J=`<a href="/docs/transformers/main/en/main_classes/trainer#transformers.Trainer">Trainer</a> uses the <code>HfTrainerDeepSpeedConfig</code> subclass instead. That subclass has logic to sync the configuration
with values of <a href="/docs/transformers/main/en/main_classes/trainer#transformers.TrainingArguments">TrainingArguments</a> by replacing special placeholder values: <code>&quot;auto&quot;</code>. Without this special logic
the DeepSpeed configuration is not modified in any way.`,k,H,z;return g=new K({props:{title:"DeepSpeed",local:"deepspeed",headingTag:"h1"}}),c=new ne({props:{$$slots:{default:[se]},$$scope:{ctx:y}}}),_=new K({props:{title:"HfDeepSpeedConfig",local:"transformers.integrations.HfDeepSpeedConfig",headingTag:"h2"}}),$=new re({props:{name:"class transformers.integrations.HfDeepSpeedConfig",anchor:"transformers.integrations.HfDeepSpeedConfig",parameters:[{name:"config_file_or_dict",val:""}],parametersDescription:[{anchor:"transformers.integrations.HfDeepSpeedConfig.config_file_or_dict",description:"<strong>config_file_or_dict</strong> (<code>Union[str, Dict]</code>) &#x2014; path to DeepSpeed config file or dict.",name:"config_file_or_dict"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/integrations/deepspeed.py#L55"}}),{c(){n=f("meta"),d=l(),i=f("p"),T=l(),q(g.$$.fragment),C=l(),u=f("p"),u.innerHTML=N,x=l(),h=f("p"),h.innerHTML=W,P=l(),q(c.$$.fragment),L=l(),q(_.$$.fragment),M=l(),s=f("div"),q($.$$.fragment),O=l(),b=f("p"),b.textContent=B,Z=l(),D=f("p"),D.innerHTML=F,G=l(),w=f("p"),w.innerHTML=J,k=l(),H=f("p"),this.h()},l(e){const t=ae("svelte-u9bgzb",document.head);n=m(t,"META",{name:!0,content:!0}),t.forEach(a),d=p(e),i=m(e,"P",{}),I(i).forEach(a),T=p(e),j(g.$$.fragment,e),C=p(e),u=m(e,"P",{"data-svelte-h":!0}),S(u)!=="svelte-117asva"&&(u.innerHTML=N),x=p(e),h=m(e,"P",{"data-svelte-h":!0}),S(h)!=="svelte-1q4kp4d"&&(h.innerHTML=W),P=p(e),j(c.$$.fragment,e),L=p(e),j(_.$$.fragment,e),M=p(e),s=m(e,"DIV",{class:!0});var o=I(s);j($.$$.fragment,o),O=p(o),b=m(o,"P",{"data-svelte-h":!0}),S(b)!=="svelte-g6t8ro"&&(b.textContent=B),Z=p(o),D=m(o,"P",{"data-svelte-h":!0}),S(D)!=="svelte-xzx2jk"&&(D.innerHTML=F),G=p(o),w=m(o,"P",{"data-svelte-h":!0}),S(w)!=="svelte-1q5z43w"&&(w.innerHTML=J),o.forEach(a),k=p(e),H=m(e,"P",{}),I(H).forEach(a),this.h()},h(){V(n,"name","hf:doc:metadata"),V(n,"content",oe),V(s,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,t){v(document.head,n),r(e,d,t),r(e,i,t),r(e,T,t),A(g,e,t),r(e,C,t),r(e,u,t),r(e,x,t),r(e,h,t),r(e,P,t),A(c,e,t),r(e,L,t),A(_,e,t),r(e,M,t),r(e,s,t),A($,s,null),v(s,O),v(s,b),v(s,Z),v(s,D),v(s,G),v(s,w),r(e,k,t),r(e,H,t),z=!0},p(e,[t]){const o={};t&2&&(o.$$scope={dirty:t,ctx:e}),c.$set(o)},i(e){z||(E(g.$$.fragment,e),E(c.$$.fragment,e),E(_.$$.fragment,e),E($.$$.fragment,e),z=!0)},o(e){U(g.$$.fragment,e),U(c.$$.fragment,e),U(_.$$.fragment,e),U($.$$.fragment,e),z=!1},d(e){e&&(a(d),a(i),a(T),a(C),a(u),a(x),a(h),a(P),a(L),a(M),a(s),a(k),a(H)),a(n),R(g,e),R(c,e),R(_,e),R($)}}}const oe='{"title":"DeepSpeed","local":"deepspeed","sections":[{"title":"HfDeepSpeedConfig","local":"transformers.integrations.HfDeepSpeedConfig","sections":[],"depth":2}],"depth":1}';function le(y){return X(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ge extends ee{constructor(n){super(),te(this,n,le,ie,Q,{})}}export{ge as component};
